using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
//Avatar Aang
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), //item to derive from
        NameOverride = "Avatar Aang", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "My name is Oong", //new item description
        CategoryOverride = ModAPI.FindCategory("Entities"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("avataroong.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //load textures for each layer (see Human textures folder in this repository)
            var skin = ModAPI.LoadTexture("skin layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");

            //get person
            var person = Instance.GetComponent<PersonBehaviour>();

            //use the helper function to set each texture
            //parameters are as follows: 
            //  skin texture, flesh texture, bone texture, sprite scale
            //you can pass "null" to fall back to the original texture
            person.SetBodyTextures(skin, flesh, bone, 1);

            //change procedural damage colours if they interfere with your texture (rgb 0-255)
            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), 
        NameOverride = "Katara", 
        DescriptionOverride = "Stealing is wrong... Unless its from pirates",
        CategoryOverride = ModAPI.FindCategory("Entities"), 
        ThumbnailOverride = ModAPI.LoadSprite("kotoro.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("katara layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");

            var person = Instance.GetComponent<PersonBehaviour>();

            person.SetBodyTextures(skin, flesh, bone, 1);

            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4); 
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), 
        NameOverride = "Katara", 
        DescriptionOverride = "Stealing is wrong... Unless its from pirates",
        CategoryOverride = ModAPI.FindCategory("Entities"), 
        ThumbnailOverride = ModAPI.LoadSprite("kotoro.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("katara layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");

            var person = Instance.GetComponent<PersonBehaviour>();

            person.SetBodyTextures(skin, flesh, bone, 1);

            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4); 
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), 
        NameOverride = "Zuko", 
        DescriptionOverride = "I must capture the avatar and regain my honor!",
        CategoryOverride = ModAPI.FindCategory("Entities"), 
        ThumbnailOverride = ModAPI.LoadSprite("zoku.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("zuko layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");

            var person = Instance.GetComponent<PersonBehaviour>();

            person.SetBodyTextures(skin, flesh, bone, 1);

            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4); 
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), 
        NameOverride = "Sokka", 
        DescriptionOverride = "Drink cactus juice. It'll quench ya! Nothing's quenchier! It's the quenchiest!",
        CategoryOverride = ModAPI.FindCategory("Entities"), 
        ThumbnailOverride = ModAPI.LoadSprite("soka.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("sokka layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");

            var person = Instance.GetComponent<PersonBehaviour>();

            person.SetBodyTextures(skin, flesh, bone, 1);

            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4); 
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Baseball Bat"), //item to derive from
        NameOverride = "Sokka's club", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The club sokka used", //new item description
        CategoryOverride = ModAPI.FindCategory("Melee"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("club.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //get the SpriteRenderer and replace its sprite with a custom one
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("club.png");
                                        Instance.FixColliders();
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Pulse Drum"), //item to derive from
        NameOverride = "Aang's glider -Closed form", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "The glider aang used to help him out with airbending and flight", //new item description
        CategoryOverride = ModAPI.FindCategory("Melee"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("thestick.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //get the SpriteRenderer and replace its sprite with a custom one
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("thestick.png");
            PhysicalBehaviour phys = Instance.GetComponent<PhysicalBehaviour>();
   phys.Properties = ModAPI.FindPhysicalProperties("Wood");
                                        Instance.FixColliders();
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), 
        NameOverride = "AvatarState Aang", 
        DescriptionOverride = "Aang in avatar state",
        CategoryOverride = ModAPI.FindCategory("Entities"), 
        ThumbnailOverride = ModAPI.LoadSprite("avatarstateoong.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("avatar layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");

            var person = Instance.GetComponent<PersonBehaviour>();
            foreach (var Limbs in person.Limbs)

            person.SetBodyTextures(skin, flesh, bone, 1);
            foreach (var Limbs in person.Limbs)
            {
              Limbs.Health *= 30f;
              Limbs.BreakingThreshold *= 30f;

            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);
            } 
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Flamethrower"), //item to derive from
        NameOverride = "Firebending", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Firebending comes from the breath and is located in the stomach.", //new item description
        CategoryOverride = ModAPI.FindCategory("Firearms"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("Firebending.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //get the SpriteRenderer and replace its sprite with a custom one
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Firebending.png");
            PhysicalBehaviour phys = Instance.GetComponent<PhysicalBehaviour>();
   phys.Properties = ModAPI.FindPhysicalProperties("Insulator");
                                        Instance.FixColliders();
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Human"), 
        NameOverride = "Toph Beifong", 
        DescriptionOverride = "My name's Toph because it sounds like tough",
        CategoryOverride = ModAPI.FindCategory("Entities"), 
        ThumbnailOverride = ModAPI.LoadSprite("tough.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) =>
        {
            var skin = ModAPI.LoadTexture("toph layer.png");
            var flesh = ModAPI.LoadTexture("flesh layer.png");
            var bone = ModAPI.LoadTexture("bone layer.png");

            var person = Instance.GetComponent<PersonBehaviour>();
            foreach (var Limbs in person.Limbs)

            person.SetBodyTextures(skin, flesh, bone, 1);
            foreach (var Limbs in person.Limbs)
            {
              Limbs.Health *= 11f;
              Limbs.BreakingThreshold *= 12f;

            person.SetBruiseColor(86, 62, 130);
            person.SetSecondBruiseColor(154, 0, 7);
            person.SetThirdBruiseColor(207, 206, 120);
            person.SetRottenColour(202, 199, 104);
            person.SetBloodColour(108, 0, 4);
            } 
        }
    }
);
ModAPI.Register(
    new Modification()
    {
        OriginalItem = ModAPI.FindSpawnable("Stormbaan"), //item to derive from
        NameOverride = "Lightning Bending", //new item name with a suffix to assure it is globally unique
        DescriptionOverride = "Lightning comes from peace of mind Some call it the Cold blooded fire.", //new item description
        CategoryOverride = ModAPI.FindCategory("Firearms"), //new item category
        ThumbnailOverride = ModAPI.LoadSprite("lightningtending.png"), //new item thumbnail (relative path)
        AfterSpawn = (Instance) => //all code in the AfterSpawn delegate will be executed when the item is spawned
        {
            //get the SpriteRenderer and replace its sprite with a custom one
            Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Lightningbending.png");
            PhysicalBehaviour phys = Instance.GetComponent<PhysicalBehaviour>();
   phys.Properties = ModAPI.FindPhysicalProperties("Insulator");
                                        Instance.FixColliders();
        }
    }
);
        } 
    }
}